<template>
    <q-img :src="Image" style="height: 135px">
        <div class="absolute-bottom bg-transparent ">
            <div class="row items-center q-gutter-x-md">
                <q-avatar size="64px" class="q-mb-sm">
                    <img :src="Avatar" :alt="AutoAvatar">
                </q-avatar>
                <div>
                    <div class="text-weight-bold">{{ Name }}</div>
                    <div>@{{ Handle }}</div>
                </div>
            </div>
            <q-btn label="Manage Project" color="primary" to="/project/home"/>
        </div>
    </q-img>

</template>

<style lang='scss' scoped>
.profile {
    width: 100%;

}

</style>

<script lang='ts'>
import {Component, Vue} from 'vue-property-decorator';
import {Auth0User} from "src/classLibrary/Core/Auth0";
import {GenerateAvatar} from "src/classLibrary/AvatarGenerator";
import {goodOnes} from "boot/assets";


@Component
export default class Profile extends Vue {

    get User(): Auth0User | null | undefined {
        return this.$auth.user;
    }


    get AutoAvatar(): string {
        return GenerateAvatar(this.Name)
    }


    get Image(): string {
        return this.$images.md[`${this.mdBackground}index`];
    }

    get Avatar(): string {
        return this.User?.picture ?? this.AutoAvatar;
    }

    get Name(): string {
        return this.$coreAuth.user?.principal.fields.name ?? "Unknown User";
    }

    get Handle(): string {
        return this.$coreAuth.user?.principal.username ?? "unknown_user";
    }

    get mdBackground(): number {
        return this.$coreAuth.user?.principal.materialBackground || goodOnes.Random()!;
    }
}
</script>
